#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

const int groups = 3;
const long long minValue[groups] = {0, 0, 0};
const long long maxValue[groups] = {100, 300 * 1000, (long long)1e18};

int main(int argc, char ** argv) {
	registerValidation(argc, argv);

	int group = atoi(validator.group().data());
	ensuref(0 <= group && group <= 3, "Wrong group number");

	group--;
	if (group == -1)
		group = 0;

	inf.readLong(minValue[group], maxValue[group], "n");
	inf.readEoln();
	long long a = inf.readLong(minValue[group], maxValue[group], "a");	
	inf.readEoln();
	inf.readLong(a, maxValue[group], "b");
	inf.readEoln();
	long long c = inf.readLong(minValue[group], maxValue[group], "c");
	inf.readEoln();
	inf.readLong(c, maxValue[group], "d");
	inf.readEoln();
	inf.readEof();

    return 0;
}