#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);

	if (argc != 8) {
		cerr << "Usage: n, k, minT, maxT, minC, maxC, seed" << endl; 

		return 1;
	}

    int n = atoi(argv[1]);
    int k = atoi(argv[2]);
    int minT = atoi(argv[3]);
    int maxT = atoi(argv[4]);
    int minC = atoi(argv[5]);
    int maxC = atoi(argv[6]);

    vector <int> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
    	a[i] = rnd.next(minT, maxT);
    	b[i] = rnd.next(minC, maxC);
    	c[i] = a[i];
    }

    for (int i = 0; i < k; i++) {
    	int p = rnd.next(0, n - 1);
    	c[p] = max(1, c[p] - 1);
    }

    cout << n << endl;
    for (int i = 0; i < n; i++) {
    	cout << a[i] << " \n"[i == n - 1];
    }
    for (int i = 0; i < n; i++) {
    	cout << b[i] << " \n"[i == n - 1];
    }
    for (int i = 0; i < n; i++) {
    	cout << c[i] << " \n"[i == n - 1];
    }



    return 0;
}