#include <iostream>
#include <cmath>
#include <cstdio>
#include <cassert>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <algorithm>
#include <cstring>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),(a).end()

int main(int argc, char ** argv) {
  registerGen(argc, argv, 1);
  
  if (argc < 4) {
    cerr << "Usage: n q pos" << endl;    
    return 1;
  }

  int n = atoi(argv[1]);
  int q = atoi(argv[2]);
  int pos = atoi(argv[3]);
  printf("%d %d\n", n, q);
  int l1, r1, l2, r2;
  if (pos == 0) {
    l1 = rnd.next(1, n);
    l2 = rnd.next(1, n);
  } else {
    assert(pos >= 1 && pos <= 4);
    l1 = (n - 1) * ((pos - 1) % 2) + 1;
    l2 = (n - 1) * ((pos - 1) / 2) + 1;
  }
  r1 = l1;
  r2 = l2;  
  printf("%d %d %d %d\n", l1, l2, r1, r2);
  return 0;
}
