#include "testlib.h"
#include <limits.h>
#include <assert.h>
using namespace std;
const int maxn[] = {(int)2e9, 10, 100, (int)1e4, (int)2e9, (int)2e9};
const int maxq[] = {(int)1e3,
                    maxn[1] * maxn[1] * maxn[1] * maxn[1], 
                    maxn[2] * maxn[2], 
                    maxn[3] * 2, 
                    128, 
                    64};
int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
    int group = atoi(validator.group().data());
    assert(0 <= group && group <= 5);
    int n = inf.readInt(1, maxn[group], "n");
    inf.readSpace();
    int q = inf.readInt(1, maxq[group], "q");
    inf.readEoln();
    int lx = inf.readInt(1, n, "lx");
    inf.readSpace();
    int ly = inf.readInt(1, n, "ly");
    inf.readSpace();
    int rx = inf.readInt(lx, n, "rx");
    inf.readSpace();
    int ry = inf.readInt(ly, n, "ry");
    inf.readEoln();
    
    inf.readEof();

    return 0;
}
