#include <iostream>
#include <cmath>
#include <cstdio>
#include <cassert>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <algorithm>
#include <cstring>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),(a).end()
map<int, int> M;
set<int> used;
int alp;
int get(int x) {
  if (M.count(x) == 0) {
    int y;
    while (1) {
      y = rnd.next(1, alp);
      if (used.count(y) == 0) {
        used.insert(y);
        break;
      }
    }
    M[x] = y;
  }
  return M[x];
}

int main(int argc, char ** argv) {
  registerGen(argc, argv, 1);
  
  if (argc < 4) {
    cerr << "Usage: n, m, alp" << endl;    
    return 1;
  }

  int n = atoi(argv[1]);
  int m = atoi(argv[2]);
  alp = atoi(argv[3]);
  m = min(m, int(alp / 2) - 3);  
  int s = int(n / 2);
  vector<vector<int> > ls(n);
  vector<set<int> > ls2(n);
  for (int i = 0; i < int(m * 2); i++) {
    int x = get(i + 1);
    set<int> st;
    while (sz(st) < s) {
      st.insert(rnd.next(0, n - 1));
    }
    for (auto y : st) {
      ls[y].pb(x);
    }
  }

  for (int i = 0; i < n; i++) {
    shuffle(all(ls[i]));
    if (sz(ls[i]) > m) {
      ls[i].resize(m);
    }
    for (auto x : ls[i]) {
      ls2[i].insert(x);
    }
    while (sz(ls2[i]) < m) {
      ls2[i].insert(rnd.next(1, alp));
    }
  }
  printf("%d %d\n", n, m);
  for (int i = 0; i < n; i++) {    
    vector<int> l(ls2[i].begin(), ls2[i].end());
    shuffle(all(l));
    for (int j = 0; j < m; j++) {
      printf("%d%c", l[j], " \n"[j + 1 == m]);
    }
  }
  return 0;
}