#include <iostream>
#include <cmath>
#include <cstdio>
#include <cassert>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <algorithm>
#include <cstring>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),(a).end()
map<int, int> M;
set<int> used;
int alp2;
int get(int x) {
  if (M.count(x) == 0) {
    int y;
    while (1) {
      y = rnd.next(1, alp2);
      if (used.count(y) == 0) {
        used.insert(y);
        break;
      }
    }
    M[x] = y;
  }
  return M[x];
}

int main(int argc, char ** argv) {
  registerGen(argc, argv, 1);
  
  if (argc < 6) {
    cerr << "Usage: n, m, alp, alp2, max_flag" << endl;    
    return 1;
  }

  int n = atoi(argv[1]);
  int m = atoi(argv[2]);
  int alp = atoi(argv[3]);
  alp2 = atoi(argv[4]);
  int flag = atoi(argv[5]);
  m = min(m, alp - 3);
  if (!flag) {
    n = rnd.next(2, n);
    m = rnd.next(2, m);
  }
  printf("%d %d\n", n, m);
  set<set<int> > SS;
  for (int i = 0; i < n; i++) {    
    set<int> S;
    while (1) {
      S.clear();
      while (sz(S) < m) {
        S.insert(get(rnd.next(1, alp)));
      }
      if (SS.find(S) == SS.end()) {
        SS.insert(S);
        break;
      }
    }
    vector<int> ls(S.begin(), S.end());
    shuffle(all(ls));
    for (int j = 0; j < m; j++) {
      printf("%d%c", ls[j], " \n"[j + 1 == m]);
    }
  }
  return 0;
}