#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn[] = {10000, 2, 2, 2, 50, 10000, 2000};
const int maxm[] = {100000, int(1e3), int(1e5), int(1e5), 50, 200, 1000};
const int maxc[] = {1000000000, int(1e9), int(1e5), int(1e9), int(1e9), 200, int(1e9)};

int main(int argc, char* argv[]) {
  registerValidation(argc, argv);
  int group = atoi(validator.group().data());
  ensure(group >= 0 && group <= 6);
  int n = inf.readInt(1, maxn[group]);
  inf.readSpace();
  int m = inf.readInt(1, maxm[group]);
  inf.readEoln();
  set<vector<int> > S;
  for (int i = 0; i < n; i++) {
    vector<int> v;
    for (int j = 0; j < m; j++) {
      v.push_back(inf.readInt(1, maxc[group]));
      if (j + 1 == m) {
        inf.readEoln();        
      } else {
        inf.readSpace();        
      }
    }
    sort(v.begin(), v.end());
    for (int j = 0; j + 1 < m; j++) {
      ensure(v[j] != v[j + 1]);
    }
    ensure(S.find(v) == S.end());
    S.insert(v);
  }
  inf.readEof();
}