#include <bits/stdc++.h>

using namespace std;

bitset<200> bitsets[10000];
void solve_bitset(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int c;
            scanf("%d", &c);
            bitsets[i].set(c - 1);
        }
    }
    int result = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            result = max(result, (int) (bitsets[i] & bitsets[j]).count() + 1);
        }
    }
    printf("%d\n", result);
}

int main() {
    int n, m;
    scanf("%d%d", &n, &m);

    if (n == 1) {
        puts("0");
        return 0;
    }

    if (n > 2000) {
        solve_bitset(n, m);
        return 0;
    }

    vector< vector<int> > sets(n, vector<int>(m));
    unordered_map<int, vector<int> > groups;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int c;
            scanf("%d", &c);
            sets[i][j] = c;
            if (groups.find(c) == groups.end()) groups[c] = vector<int>();
            groups[c].push_back(i);
        }
    }
    unordered_set<int> reversed;
    for (auto &p: groups) {
        if (p.second.size() <= n / 2) continue;
        reversed.insert(p.first);
        set<int> t; for (int i = 0; i < n; i++) t.insert(i);
        for (auto i: p.second) {
            t.erase(i);
        }
        p.second = vector<int>(t.begin(), t.end());
    }

    int result = 1;
    for (int i = n - 1; i >= 0; i--) {
        vector<int> pos(i), neg(i);
        int inc = 1;
        for (int j: sets[i]) {
            while (!groups[j].empty() && groups[j].back() >= i) groups[j].pop_back();
            if (reversed.find(j) != reversed.end()) {
                inc++;
                for (int k: groups[j]) neg[k]++;
            } else {
                for (int k: groups[j]) pos[k]++;
            }
        }
        for (int j = 0; j < i; j++) {
            result = max(result, pos[j] + inc - neg[j]);
        }
    }

    printf("%d\n", result);
}