/*
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int len_log;
int k;
vector<string> res;

string gen_rnd(int len) {
    return rnd.next(format("[a-z]{%d}", len));
}

string gen_tm(int len_log, char a, char b) {
    int len = (1 << len_log);
    string s(len, '#');
    for (int i = 0; i < len; ++i) {
        s[i] = (__builtin_popcount(i) & 1 ? a : b);
    }
    return s;
}

void gen_chars(char &a, char &b) {
    vector< pair<char, char> > g;
    for (char i = 'a'; i <= 'z'; ++i) {
        for (char j = 'a'; j <= 'z'; ++j) {
            if (i != j) {
                g.push_back({i, j});
            }
        }
    }
    auto chars = rnd.any(g.begin(), g.end());
    a = chars.first;
    b = chars.second;
}

void out_ah(int len_log) {
    char a, b;
    gen_chars(a, b);
    string s = gen_tm(len_log, a, b);
    string t = (s.substr(0, (int)s.size() - 1) +
                gen_tm(len_log, b, a));
    res.push_back(s);
    res.push_back(t);
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    len_log = atoi(argv[2]);
    k = atoi(argv[3]);

    for (int i = 0; i + 2 <= k; i += 2) {
        out_ah(len_log);
    }
    while ((int)res.size() < n) {
        res.push_back(gen_rnd(1 << len_log));
    }
    shuffle(res.begin(), res.end());
    
    cout << n << endl;
    for (const string &s : res) {
        cout << s << endl;
    }
    return 0;
}
