/*
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int len;
int k;
vector<string> res;

string gen_rnd(int len) {
    return rnd.next(format("[a-z]{%d}", len));
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    len = atoi(argv[2]);
    k = atoi(argv[3]);

    for (int i = 0; i + 2 <= n; i += 2) {
        string s = gen_rnd(len);
        res.push_back(s);
        res.push_back(s);
    }
    while ((int)res.size() < n) {
        res.push_back(gen_rnd(len));
    }
    for (int i = 0; i < k; ++i) {
        res.push_back(rnd.next("[a-z]"));
    }
    shuffle(res.begin(), res.end());
    
    cout << res.size() << endl;
    for (const string &s : res) {
        cout << s << endl;
    }
    return 0;
}
