/*
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int len;
int le;
int ri;
int k;
vector<string> res;

string gen_rnd(int len) {
    return rnd.next(format("[a-z]{%d}", len));
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    len = atoi(argv[2]);
    
    string s = gen_rnd(len);
    res.push_back(s);
    for (int i = len - 1; i > 0; --i) {
        for (int j = 0; j + i <= len && (int)res.size() < n; ++j) {
            res.push_back(s.substr(j, i));
        }
    }
    shuffle(res.begin(), res.end());
    
    cout << n << endl;
    int sum = 0;
    for (const string &s : res) {
        cout << s << endl;
        sum += (int)s.size();
    }
    cerr << sum << endl;
    return 0;
}
