#include "testlib.h"
using namespace std;

const int MAXN[] = {10, 500, 100 * 1000, 1000 * 1000 * 1000};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = atoi(validator.group().data()) - 1;
    ensuref(0 <= group && group <= 3, "Incorrect test group");
    int n = inf.readInt(4, MAXN[group], "n");
    inf.readSpace();
    int k = inf.readInt(2, n / 2, "k");
    ensuref(n % k == 0, "n should be divisible by k");
    inf.readEoln();
    inf.readEof();
}
