#include "testlib.h"
#include <vector>
#include <cstdlib>
#include <algorithm>

using namespace std;

pair<int, int> sorted(pair<int, int> x) {
    if (x.first > x.second) {
        swap(x.first, x.second);
    }
    return x;
}

vector <pair<int, int> > edges;

int main(int argc, char **argv) {                                                                                                                                                                                                
    registerGen(argc, argv, 1);
    int minN = atoi(argv[1]);
    int maxN = atoi(argv[2]);
    int minK = atoi(argv[3]);
    int maxK = atoi(argv[4]);
    int minRK = atoi(argv[5]);
    int maxRK = atoi(argv[6]);
    int n = rnd.next(minN, maxN);
    int k = rnd.next(minK, maxK);
    int rk;
    if (minRK > k)
        rk = k;
    else
        rk = rnd.next(minRK, min(maxRK, k));
    long long m = 1ll * n * (n - 1) / 2;
    printf("%d %lld %d\n", n, m, k);
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            edges.push_back(make_pair(i, j));
        }
    }
    shuffle(edges.begin(), edges.end());
    for (int i = 0; i < edges.size(); ++i) {
        if (rnd.next(1, 2) == 1) {
            swap(edges[i].first, edges[i].second);
        }
        printf("%d %d %d\n", edges[i].first + 1, edges[i].second + 1, rnd.next(0, rk));
    }
    int a = rnd.next(1, n);
    int b = rnd.next(1, n);
    while (a == b)
        b = rnd.next(1, n);
    printf("%d %d\n", a, b);
    return 0;
}