#!/usr/bin/python3

n, m, k = map(int, input().split())

import sys
sys.setrecursionlimit(200000)

g = [[] for i in range(n)]

for i in range(m):
    a, b, c = map(int, input().split())
    a -= 1
    b -= 1
    g[a] += [(b, c)]
    g[b] += [(a, c)]
    
A, B = map(int, input().split())
A -= 1
B -= 1

answer = []
used = [False] * n

def dfs(v, c):
    used[v] = True
    if (v == A):
        return True
    for u in g[v]:
        if u[1] != c and not used[u[0]]:
            if (dfs(u[0], c)):
                return True
    return False

for i in range(1, k + 1):
    used = [False] * n
    if (dfs(B, i)):
        answer += [i]

print(len(answer))
for i in answer:
    print(i, end=' ')
print()
