#include <cstdio>
#include <vector>

using namespace std;

vector <int> count;
vector <bool> ans;
vector <vector <pair<int, int> > > g;
int colorsUsed = 0;
int A, B;
int k;

vector<bool> used;

void dfs(int v) {
    
    used[v] = true;
    if (v == B) {
        
        if (colorsUsed != k) {
            for (int i = 0; i < k; ++i) {
                if (!count[i])
                    ans[i] = true;
            }
        }
        used[v] = false;
        return;
    }
    
    for (int i = 0; i < g[v].size(); ++i) {
        
        if (!used[g[v][i].first]) {
            
            int c = g[v][i].second - 1;
            if (c >= 0 && count[c] == 0) {
                ++colorsUsed;
            }
            if (c >= 0)
                ++count[c];
            dfs(g[v][i].first);
            if (c >= 0)
                --count[c];
            if (c >= 0 && count[c] == 0) {
                --colorsUsed;
            }
        }
    }
    used[v] = false;
}

int main() {
    int n, m;
    scanf("%d %d %d", &n, &m, &k);
    used.assign(n, 0);
    g.resize(n);
    count.assign(k, 0);
    ans.assign(k, false);
    
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        scanf("%d %d %d", &a, &b, &c);
        --a, --b;
        g[a].push_back(make_pair(b, c));
        g[b].push_back(make_pair(a, c));
    }
    scanf("%d %d", &A, &B);
    --A, --B;
    dfs(A);
    vector <int> answ;
    for (int i = 0; i < k; ++i) {
        if (ans[i])
            answ.push_back(i + 1);
    }
    printf("%d\n", answ.size());
    for (int i = 0; i < answ.size(); ++i)
        printf("%d ", answ[i]);
    printf("\n");
    
}