#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define image(a) {sort(all(a)), a.resize(unique(all(a)) - a.begin());}
vector<int> calcdp(string a, string b) {
  vector<int> dp0 = vector<int>(sz(a) + 1);
  for (int i = 0; i <= sz(b); i++) {
    vector<int> dp1 = vector<int>(sz(a) + 1);
    for (int j = 0; j <= sz(a); j++) {
      if (i < sz(b) && j < sz(a) && a[j] == b[i]) {
        dp1[j + 1] = max(dp1[j + 1], dp0[j] + 1);
      }
      if (i < sz(b)) {
        dp1[j] = max(dp1[j], dp0[j]);
      }
      if (j < sz(a)) {
        dp0[j + 1] = max(dp0[j + 1], dp0[j]);
      }
    }
    if (i < sz(b)) {
      dp0 = dp1;
    }
  }
  return dp0;
}
vector<pair<int, int>> LCS(string a, string b) {
  vector<pair<int, int>> res;
  if (sz(a) == 0 || sz(b) == 0) return res;
  if (sz(b) == 1) {
    for (int i = 0; i < sz(a); i++) {
      if (a[i] == b[0]) {
        res.pb(mp(i, 0));
        break;
      }
    }
    return res;
  }
  string b1 = b.substr(0, sz(b) / 2);
  string b2 = b.substr(sz(b) / 2, sz(b) - sz(b) / 2);
  vector<int> dp1 = calcdp(a, b1);
  string ar = a;
  reverse(all(ar));
  string b2r = b2;
  reverse(all(b2r));
  vector<int> dp2 = calcdp(ar, b2r);
  int mid = -1;
  int val = -1;
  for (int i = 0; i <= sz(a); i++) {
    if (dp1[i] + dp2[sz(a) - i] > val) {
      mid = i;
      val = dp1[i] + dp2[sz(a) - i];
    }
  }
  if (val == 0) return res;
  string a1 = a.substr(0, mid);
  string a2 = a.substr(mid, sz(a) - mid);
  res = LCS(a1, b1);
  vector<pair<int, int>> res2 = LCS(a2, b2);
  for (auto p : res2) {
    res.pb(mp(p.x + sz(a1), p.y + sz(b1)));
  }  
  return res;
}

string s;
vector<int> ans;
void bct2(int l, int r, int li, int ri) {
  if (l > r) return;
  if (l == ans[li] && r == ans[ri]) {
    cout << s[l];
    bct2(l + 1, r - 1, li + 1, ri - 1);
    if (l < r) {
      cout << s[r];
    }
  } else 
  if (l < ans[li]) {
    cout << s[l];
    bct2(l + 1, r, li, ri);
    cout << s[l];
  } else 
  if (r > ans[ri]) {
    cout << s[r];
    bct2(l, r - 1, li, ri);
    cout << s[r];
  } else {
    assert(false);
  }
}
int main(){
  #ifdef home
  assert(freopen("output.txt","wt",stdout));
  assert(freopen("input.txt","rt",stdin));
  #endif
  cin >> s;
  int n = sz(s);
  string sr = s;
  reverse(all(sr));
  vector<pair<int, int>> ls = LCS(s, sr);
  int Ans = sz(ls);
  cout << n - Ans << endl;
  int k = (Ans + 1) / 2;
  int k1 = Ans - k;
  if (ls[k - 1].x <= n - 1 - ls[k - 1].y) {
    for (int i = 0; i < k; i++) {
      ans.pb(ls[i].x);
    }
    for (int i = k1 - 1; i >= 0; i--) {
      ans.pb(n - 1 - ls[i].y);
    }
  } else {
    assert(false);
  }
  assert(sz(ans) == Ans);
  for (int i = 0; i + 1 < sz(ans); i++) {
    assert(ans[i] < ans[i + 1]);
  }
  for (int i = 0; i < sz(ans); i++) {
    assert(s[ans[i]] == s[ans[sz(ans) - 1 - i]]);
  }
  bct2(0, n - 1, 0, sz(ans) - 1);
  cout << endl;
  return 0;
}
