#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define image(a) {sort(all(a)), a.resize(unique(all(a)) - a.begin());}
string s;
string sr;
vector<int> temp[4];
vector<int>& calcdp(int l1, int r1, int l2, int r2, bool rev) {
  int len1 = r1 - l1 + 1;
  int len2 = r2 - l2 + 1;
  vector<int>& dp0 = temp[0 + rev * 2];
  vector<int>& dp1 = temp[1 + rev * 2];
  for (int j = 0; j <= len1; j++) {  
    dp0[j] = dp1[j] = 0;
  }
  for (int i = 1; i <= len2; i++) {
    for (int j = 1; j <= len1; j++) {
      dp1[j] = max(dp1[j - 1], dp0[j]);
      if ((rev == 0 ? (s[j + l1 - 1] == sr[i + l2 - 1]) : (s[r1 - j + 1] == sr[r2 - i + 1])) && dp1[j] < dp0[j - 1] + 1) {
        dp1[j] = dp0[j - 1] + 1;
      }
    }
    swap(dp0, dp1);
  }
  return dp0;
}
vector<pair<int, int>> ls;
void LCS(int l1, int r1, int l2, int r2) {
  int len1 = r1 - l1 + 1;
  int len2 = r2 - l2 + 1;
  if (len1 == 0 || len2 == 0) return;
  if (len2 == 1) {
    for (int i = l1; i <= r1; i++) {
      if (s[i] == sr[l2]) {
        ls.pb(mp(i, l2));
        break;
      }
    }
    return;
  }
  int m2 = (l2 + r2) / 2;
  vector<int>& dp1 = calcdp(l1, r1, l2, m2, 0);
  vector<int>& dp2 = calcdp(l1, r1, m2 + 1, r2, 1);
  int mid = -1;
  int val = -1;
  for (int i = 0; i <= len1; i++) {
    if (dp1[i] + dp2[len1 - i] > val) {
      mid = i;
      val = dp1[i] + dp2[len1 - i];
    }
  }
  if (val == 0) return;
  int m1 = l1 + mid - 1;
  LCS(l1, m1, l2, m2);
  LCS(m1 + 1, r1, m2 + 1, r2);
}


vector<int> ans;
void bct2(int l, int r, int li, int ri) {
  if (l > r) return;
  if (l == ans[li] && r == ans[ri]) {
    cout << s[l];
    bct2(l + 1, r - 1, li + 1, ri - 1);
    if (l < r) {
      cout << s[r];
    }
  } else 
  if (l < ans[li]) {
    cout << s[l];
    bct2(l + 1, r, li, ri);
    cout << s[l];
  } else 
  if (r > ans[ri]) {
    cout << s[r];
    bct2(l, r - 1, li, ri);
    cout << s[r];
  } else {
    assert(false);
  }
}
int main(){
  #ifdef home
  assert(freopen("output.txt","wt",stdout));
  assert(freopen("input.txt","rt",stdin));
  #endif
  cin >> s;
  int n = sz(s);
  for (int i = 0; i < 4; i++) {
    temp[i] = vector<int>(n + 1);
  }
  sr = s;
  reverse(all(sr));
  LCS(0, n - 1, 0, n - 1);
  int Ans = sz(ls);
  cout << n - Ans << endl;
  int k = (Ans + 1) / 2;
  int k1 = Ans - k;
  if (ls[k - 1].x <= n - 1 - ls[k - 1].y) {
    for (int i = 0; i < k; i++) {
      ans.pb(ls[i].x);
    }
    for (int i = k1 - 1; i >= 0; i--) {
      ans.pb(n - 1 - ls[i].y);
    }
  } else {
    assert(false);
  }
  assert(sz(ans) == Ans);
  for (int i = 0; i + 1 < sz(ans); i++) {
    assert(ans[i] < ans[i + 1]);
  }
  for (int i = 0; i < sz(ans); i++) {
    assert(s[ans[i]] == s[ans[sz(ans) - 1 - i]]);
  }
  bct2(0, n - 1, 0, sz(ans) - 1);
  cout << endl;
  return 0;
}
