def find_prime_divisors_sqrt(n):
    divisors = []
    m = 2
    while m * m <= n:
        while n % m == 0:
            divisors.append(m)
            n //= m
        m += 1
    if n != 1:
        divisors.append(n)
    return divisors
 

n = int(input())
prime_divisors = find_prime_divisors_sqrt(n - 1)
print(len(prime_divisors))
print(' '.join(map(lambda x: str(x - 1), prime_divisors)))
