#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

const int groups = 3;
const int minN[groups] = {1, 1, 1};
const int maxN[groups] = {1000, 200 * 1000, 200 * 1000};
const int minD[groups] = {0, 0, 0};
const int maxD[groups] = {0, 200 * 1000, 1000 * 1000 * 1000};
const int minC[groups] = {0, 0, 0};
const int maxC[groups] = {1000, 200 * 1000, 1000 * 1000 * 1000};

int main(int argc, char ** argv) {
	registerValidation(argc, argv);

	int cg = atoi(validator.group().data());
	ensuref(0 <= cg && cg <= 3, "Wrong group number");
    cg--;

	if (cg == -1)
		cg = 2;

	int n = inf.readInt(minN[cg], maxN[cg], "n");
	inf.readSpace();
	inf.readInt(minD[cg], maxD[cg], "d");
	inf.readEoln();

	for (int i = 0; i < n; i++) {
		inf.readInt(minC[cg], maxC[cg], "c_i");
		if (i == n - 1)
			inf.readEoln();
		else
			inf.readSpace();
	}

	inf.readEof();

    return 0;
}