#include "testlib.h"
#include <cstdio>

using namespace std;

#define MAX_DAYS 1000000
#define MAX_SEGMENTS 100000

typedef struct seg {
int start;
int end;
} segment;

int mask[MAX_DAYS];
segment segments[MAX_SEGMENTS];
int n_segments=0;


int main(int argc, char* argv[])
{
int a,b,c;
    registerGen(argc, argv);

    int K=1,L=1;
    
    if (argc>1) 
     {
      sscanf (argv[1],"%d/%d",&L,&K);
     }

    sscanf (argv[2],"%d",&a);
    sscanf (argv[3],"%d",&b);
    sscanf (argv[4],"%d",&c);

    for (int i=0;i<a;i++)
     mask[i]=rnd.next(0,K-1);

   bool started=false;
   
   for (int i=0;i<a;i++)
    {
     if ( (!started) && (mask[i]<L) ) {segments[n_segments].start=i+1;started=true;}
     else if (started) 
      {
        if (mask[i]>=L) {segments[n_segments++].end=i;started=false;}
         else if (i==a-1) segments[n_segments++].end=a;
      if ( n_segments == MAX_SEGMENTS ) break;
      }
    }

//   shuffle (segments,segments+n_segments);

   printf ("%d %d %d %d\n",n_segments,a,b,c);

   for (int i=0;i<n_segments;i++)
    printf ("%d %d\n",segments[i].start,segments[i].end);

    return 0;
}
