#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
const int maxn = (int)2e6 + 10;
int was[maxn];
int sum[maxn];
vector<int> g[maxn];
void add(int i, int j) {
  g[i].pb(j);
  g[j].pb(i);
}
ull sqr(ll x) {
  ull x1;
  if (x > 0) {
      x1 = x;
  } else {
      x1 = -x;
  }
  return x1 * x1;
}
void dfs(int v) {
  if (was[v] == 1) return;
  was[v] = 1;
  for (int e : g[v]) {
    dfs(e);
  }
}
int pos(ull d, ll r1, ll r2) {
  if (d > sqr(r1 + r2)) return 0;
  if (r2 < r1 && d < sqr(r1 - r2)) return 1;
  if (r1 < r2 && d < sqr(r1 - r2)) return 3;
  return 2;  
}
bool kas(ull d, ll r1, ll r2) {
  if (d == sqr(r1 + r2)) return true;
  if (d == sqr(r1 - r2)) return true;
  return false;  
}
int main(){                    
  #ifdef home
  assert(freopen("a.out","wt",stdout));
  assert(freopen("a.in","rt",stdin));
  #endif
  int x1, y1;
  scanf("%d %d", &x1, &y1);
  int n;
  scanf("%d", &n);
  vector<int> ls1(n);
  for (int i = 0; i < n; i++) {
    scanf("%d", &ls1[i]);
  }
  int x2, y2;
  scanf("%d %d", &x2, &y2);
  int m;
  scanf("%d", &m);
  vector<int> ls2(m);
  for (int i = 0; i < m; i++) {
    scanf("%d", &ls2[i]);
  }
  ull d = sqr(x1 - x2) + sqr(y1 - y2);
  ll V = 0;
  ll E = 0;
  for (int i = 0; i < n; i++) {
    int L = 0;
    int R = m;
    while (L < R) {
      int M = (L + R) / 2;
      if (pos(d, ls1[i], ls2[M]) <= 1) {
        L = M + 1;
      } else {
        R = M;
      }
    }
    int F1 = L;
    L = 0;
    R = m;
    while (L < R) {
      int M = (L + R) / 2;
      if (pos(d, ls1[i], ls2[M]) <= 2) {
        L = M + 1;
      } else {
        R = M;
      }
    }
    int F2 = L;
    if (F1 < F2) {
      sum[F1]++;
      sum[F2 - 1]--;
      add(i, n + F1);      
      V += 2 * (F2 - F1);
      E += 4 * (F2 - F1);
      if (kas(d, ls1[i], ls2[F1])) {
        V--;
        E -= 2;
      }
      if (F2 - F1 >= 2 && kas(d, ls1[i], ls2[F2 - 1])) {
        V--;
        E -= 2;
      }
    }
  }
  int cur = 0;
  for (int i = 0; i + 1 < m; i++) {
    cur += sum[i];
    if (cur) {
      add(n + i, n + i + 1);
    }
  }
  int K = 0;
  for (int i = 0; i < n + m; i++) if (was[i] == 0) {
    dfs(i);
    K++;
  }
  ll G = 1 + K - (V - E);  
  cout << G - 1 << endl;
  return 0;
}
