#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define image(a) {sort(all(a)), a.resize(unique(all(a)) - a.begin());}
const ld eps = 1e-8;
struct pnt {
  ld x, y;
};
pnt operator - (const pnt& a, const pnt& b) {
  return {a.x - b.x, a.y - b.y};
}
ld sp(const pnt& a, const pnt& b) {
  return a.x * b.x + a.y * b.y;
}
const ld dx[] = {1, 0, -1,  0};
const ld dy[] = {0, 1,  0, -1};
int was[200010];
int sum[200010];
vector<int> g[200010];
void add(int i, int j) {
  g[i].pb(j);
  g[j].pb(i);
}
void dfs(int v) {
  if (was[v] == 1) return;
  was[v] = 1;
  for (auto e : g[v]) {
    dfs(e);
  }
}
int pos(ld d, ld r1, ld r2) {
  if (d > r1 + r2 + eps) return 0;
  if (d + r2 + eps < r1) return 1;
  if (d + r1 + eps < r2) return 3;
  return 2;  
}
bool kas(ld d, ld r1, ld r2) {
  if (fabs(d - (r1 + r2)) <= eps) return true;
  if (fabs(r1 - (d + r2)) <= eps) return true;
  if (fabs(r2 - (d + r1)) <= eps) return true;
  return false;  
}
int main(){                    
  #ifdef home
  assert(freopen("a.out","wt",stdout));
  assert(freopen("a.in","rt",stdin));
  #endif
  cin.tie(0);
  ios_base::sync_with_stdio(false);           
  pnt p0;
  cin >> p0.x >> p0.y;
  int n;
  cin >> n;
  vector<ld> ls1;
  for (int i = 0; i < n; i++) {
    ld x;
    cin >> x;
    ls1.pb(x);
  }
  pnt p1;
  cin >> p1.x >> p1.y;
  int m;
  cin >> m;
  vector<ld> ls2;
  for (int i = 0; i < m; i++) {
    ld x;
    cin >> x;
    ls2.pb(x);
  }
  ld d = sqrt(sp(p0 - p1, p0 - p1));
  p0 = {0, 0};
  p1 = {d, 0};
  ll V = 0;
  ll E = 0;
  for (int i = 0; i < n; i++) {
    int L = 0;
    int R = m;
    while (L < R) {
      int M = (L + R) / 2;
      if (pos(d, ls1[i], ls2[M]) <= 1) {
        L = M + 1;
      } else {
        R = M;
      }
    }
    int F1 = L;
    L = 0;
    R = m;
    while (L < R) {
      int M = (L + R) / 2;
      if (pos(d, ls1[i], ls2[M]) <= 2) {
        L = M + 1;
      } else {
        R = M;
      }
    }
    int F2 = L;
    if (F1 < F2) {
      sum[F1]++;
      sum[F2 - 1]--;
      add(i, n + F1);      
      V += 2 * (F2 - F1);
      E += 4 * (F2 - F1);
      if (kas(d, ls1[i], ls2[F1])) {
        V--;
        E -= 2;
      }
      if (F2 - F1 >= 2 && kas(d, ls1[i], ls2[F2 - 1])) {
        V--;
        E -= 2;
      }
    }
  }
  int cur = 0;
  for (int i = 0; i + 1 < m; i++) {
    cur += sum[i];
    if (cur) {
      add(n + i, n + i + 1);
    }
  }
  int K = 0;
  for (int i = 0; i < n + m; i++) if (was[i] == 0) {
    dfs(i);
    K++;
  }
  ll G = 1 + K - (V - E);  
  cout << G - 1 << endl;
  return 0;
}
