#include "testlib.h"
#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

using namespace std;
int int_x(int a, int b, int c, int d) {
  return max(0, min(b, d) - max(a, c) + 1);
}
int main(int argc, char* argv[])
{
  registerInteraction(argc, argv);

  int n = inf.readInt();
  int q = inf.readInt();
  int xl = inf.readInt();
  int yl = inf.readInt();
  int xr = inf.readInt();
  int yr = inf.readInt();
  printf("%d\n", n);
  fflush(NULL);

  int steps=0;  
  while (1)
  {
    string s = ouf.readToken();
    if (s == "!") {
      int xla = ouf.readInt(1, n);
      int yla = ouf.readInt(1, n);
      int xra = ouf.readInt(xla, n);
      int yra = ouf.readInt(yla, n);
      if (xla != xl || yla != yl || xra != xr || yra != yr) {
        quitf(_wa, "Wrong final rectangle");
      } else {
        tout << steps << endl;
        quitf(_ok, "%d queries processed", steps);        
      }
    }
    if (s != "?") {
      quitf (_pe, "Wrong query");
    }
    if (++steps > q) quitf(_wa, "Query limit exceeded");
    int xlq = ouf.readInt(1, n);
    int ylq = ouf.readInt(1, n);
    int xrq = ouf.readInt(xlq, n);
    int yrq = ouf.readInt(ylq, n);
    printf(INT64 "\n", (long long)int_x(xlq, xrq, xl, xr) * int_x(ylq, yrq, yl, yr));
    fflush(NULL);  
  }
}