#include <iostream>
#include <cmath>
#include <cstdio>
#include <cassert>
#include <set>
#include <map>
#include <queue>
#include <ctime>
#include <algorithm>
#include <cstring>
#include "testlib.h"

using namespace std;

typedef long long ll;
typedef long double ld;

#define x first
#define y second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),(a).end()

ld cnk(int n, int k) {
  ld c = 1;
  for (int i = 0; i < k; i++) {
    c = (c * (n - i)) / (i + 1);
  }
  return c;
}
int main(int argc, char ** argv) {
  registerGen(argc, argv, 1);
  
  if (argc < 4) {
    cerr << "Usage: n, m, alp, k" << endl;    
    return 1;
  }

  int n = atoi(argv[1]);
  int m = atoi(argv[2]);
  int alp = atoi(argv[3]);
  int k = atoi(argv[4]);
  m = min(m, alp - 6);
  int k_all;
  for (k_all = k; ; k_all++) {
    if (cnk(k_all, k) > n) {
      break;
    }
  }
  k_all++;
  assert(k_all + 1 <= m);
  set<set<int> > SS;
  for (int i = 0; i < n; i++) {    
    set<int> S;
    while (1) {
      S.clear();
      while (sz(S) < k) {
        S.insert(rnd.next(1, k_all));
      }
      if (SS.find(S) == SS.end()) {
        SS.insert(S);
        break;
      }
    }
  }
  vector<set<int> > SSV(all(SS));
  shuffle(all(SSV));
  set<int> p;
  while (sz(p) < k_all + 1) {
    p.insert(rnd.next(1, alp));
  }
  vector<int> pv(all(p));
  shuffle(all(pv));
  int i = rnd.next(1, n);
  int j;
  while (1) {
    j = rnd.next(1, n);
    if (i != j) break;
  }
  SSV[i - 1].insert(k_all + 1);
  SSV[j - 1] = SSV[i - 1];
  printf("%d %d\n", n, m);
  SS.clear();
  for (auto v : SSV) {
    set<int> s2;
    while (1) {
      s2.clear();
      for (auto x : v) {
        s2.insert(pv[x - 1]);
      }
      while (sz(s2) < m) {
        s2.insert(rnd.next(1, alp));
      }
      if (SS.find(s2) == SS.end()) {
        SS.insert(s2);
        break;
      }
    }
    vector<int> sv2(all(s2));
    shuffle(all(sv2));
    bool was = false;
    for (auto x : sv2) {
      if (!was) {
        was = true;
      } else {
        printf(" ");
      }
      printf("%d", x);
    }
    printf("\n");
  }
  return 0;
}