#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);
const int size = 2000;

int col[5 * size][size];
int cols[size * size + 1];
int fatnum[size * size + 1];
int cnt[size * size + 1];
int n, m, c;
int rem[5 * size][size];
int sum[size * size + 1];
int cur[size * size + 1];
int sethave[size * size + 1];
unsigned int ncol[5 * size][size / 5 + 1];


void solve_stupid() {
	set <int> flang;
	for (int i = 0; i < m; i++) {
		int d;
		scanf("%d", &d);
		flang.insert(d);
	}

	int ans = 1;
	for (int i = 0; i < m; i++) {
		int d;
		scanf("%d", &d);

		ans += (flang.find(d) != flang.end());
	}

	printf("%d\n", ans);
}

int main() {
	scanf("%d%d", &n, &m);

	if (n == 2) {
		solve_stupid();

		return 0;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			scanf("%d", &col[i][j]);
			cols[c++] = col[i][j];
		}

	sort(cols, cols + c);
	c = unique(cols, cols + c) - cols;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			col[i][j] = lower_bound(cols, cols + c, col[i][j]) - cols;
			cnt[col[i][j]]++;	
		}


	for (int i = 0; i < c; i++) {
		sum[i + 1] = sum[i] + cnt[i];
		cur[i] = sum[i];
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			sethave[cur[col[i][j]]++] = i;

	int magic = 400;
	int fat = 0;

	for (int i = 0; i < c; i++) {
		if (cnt[i] < magic) {
			int lb = sum[i];
			int rb = sum[i + 1];

			for (int p = lb; p < rb; p++)
				for (int q = p + 1; q < rb; q++)
					rem[sethave[p]][sethave[q]]++;
		} else {
			fatnum[i] = fat++;
		}
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++) {
			int hc = col[i][j];
			if (cnt[hc] >= magic) {
				int fn = fatnum[hc];
				ncol[i][fn / 32] |= (1u << (fn & 31));
			}
		}

	int ans = -1;
	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++) {
			int cur = rem[i][j];
			for (int p = 0; p < (fat + 31) / 32; p++)
				cur += __builtin_popcount(ncol[i][p] & ncol[j][p]);
		
			ans = max(ans, cur);
		}

	printf("%d\n", ans + 1);

    return 0;
}