/*
  Generate random strings of specified summary length.
  O(n * log^2 L)
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int sum_len;

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    sum_len = atoi(argv[1]);

    char rnd_char = (char)rnd.next('a', 'z');
    string sh = string(sum_len / 3, rnd_char);
    string lo = string(sum_len - sum_len / 3, rnd_char);
    cout << 2 << endl;
    cout << sh << endl;
    cout << lo << endl;
    return 0;
}
