/*
  Generate random strings with lengths in interval [min_len, max_len].
  O(n * max_len)
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int min_len;
int max_len;
int k;

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    min_len = atoi(argv[2]);
    max_len = atoi(argv[3]);
    k = atoi(argv[4]);

    cout << n + k << endl;
    for (int i = 0; i < n; ++i) {
        cout << rnd.next(format("[a-z]{%d,%d}", min_len, max_len)) << endl;
    }
    for (int i = 0; i < k; ++i) {
        cout << rnd.next("[a-z]") << endl;
    }
    return 0;
}
