/*
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int len_sh;
int len_lo;
int k;
vector<string> res;

string gen_rnd(int len) {
    return rnd.next(format("[a-z]{%d}", len));
}

void out_substr(int len_sh, int len_lo) {
    string sh = gen_rnd(len_sh);
    int lo_le = rnd.next(0, len_lo - len_sh);
    int lo_ri = len_lo - len_sh - lo_le;
    string lo = (gen_rnd(lo_le) + sh + gen_rnd(lo_ri));
    res.push_back(sh);
    res.push_back(lo);
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    len_sh = atoi(argv[2]);
    len_lo = atoi(argv[3]);
    k = atoi(argv[4]);
    
    for (int i = 0; i + 2 <= k; i += 2) {
        out_substr(len_sh, len_lo);
    }
    while ((int)res.size() < n) {
        res.push_back(gen_rnd(rnd.next(len_sh, len_lo)));
    }
    shuffle(res.begin(), res.end());
    
    cout << n << endl;
    for (const string &s : res) {
        cout << s << endl;
    }
    return 0;
}
