/*
*/

#include <iostream>
#include <cstdlib>
#include "testlib.h"

using namespace std;

int n;
int len;
int le;
int ri;
int k;
vector<string> res;

string gen_rnd(int len) {
    return rnd.next(format("[a-z]{%d}", len));
}

void out_pref_suff(int len, int le, int ri) {
    string s = gen_rnd(len);
    string pref = s.substr(0, len - ri) + gen_rnd(ri);
    string suff = gen_rnd(le) + s.substr(le, len - le);
    res.push_back(s);
    res.push_back(pref);
    res.push_back(suff);
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    n = atoi(argv[1]);
    len = atoi(argv[2]);
    le = atoi(argv[3]);
    ri = atoi(argv[4]);
    k = atoi(argv[5]);
    
    for (int i = 0; i + 3 <= k; i += 3) {
        out_pref_suff(len, le, ri);
    }
    while ((int)res.size() < n) {
        res.push_back(gen_rnd(len));
    }
    shuffle(res.begin(), res.end());
    
    cout << n << endl;
    for (const string &s : res) {
        cout << s << endl;
    }
    return 0;
}
