#include <iostream>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int N_MAX = 100000;
const int STR_LEN_MAX = 1000000;
const int SUM_LEN_MAX = 1000000;
int n;
int sum_len;

int main() {
    registerValidation();

    n = inf.readInt(1, N_MAX, "n");
    inf.readEoln();
    for (int i = 0; i < n; ++i) {
        string s;
        s = inf.readToken(format("[a-z]{1,%d}", STR_LEN_MAX));
        sum_len += (int)s.size();
        inf.readEoln();
    }

    ensuref(sum_len <= SUM_LEN_MAX, "The summary length of the strings exceeds the limit");
    
    inf.readEof();
    return 0;
}
