#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);

	if (argc != 6) {
		cerr << "Usage: n, d, minC, maxC, seed" << endl;

		return 1;
	}	

	int n = atoi(argv[1]);
	int d = atoi(argv[2]);
	int cl = atoi(argv[3]);
	int cr = atoi(argv[4]);
	
	set <int> dst;
	while ((int) dst.size() < n)
		dst.insert(rnd.next(cl, cr));
	
	vector <int> touse;
	while (!dst.empty()) {
		touse.pb(*dst.begin());
		dst.erase(dst.begin());
	}

	shuffle(touse.begin(), touse.end());

	printf("%d %d\n", n, d);
	for (int i = 0; i < n; i++)
		printf("%d%c", touse[i], " \n"[i == n - 1]);

    return 0;
}